unit CystINFs;

interface

var
  bCystAvailable: Boolean;

function PreloadCystINF(INFPath, CoNick: String): Boolean;





implementation

uses
  Windows, SysUtils, Classes, Forms, Registry;

type
  PPChar = ^PChar;
  TLFSetupCopyOEMInf = function (SourceInfFileName, OEMSourceMediaLocation: PChar; OEMSourceMediaType, CopyStyle: LongWord; DestinationInfFileName: PChar; DestinationInfFileNameSize: LongWord; RequiredSize: PLongWord; DestinationInfFileNameComponent: PPChar): BOOL; stdcall;

var
  hSetupAPI: THandle;
  SetupCopyOEMInf: TLFSetupCopyOEMInf;



type
  TINFThread = class(TThread)
  public
    sFN, tFN: String;
    bSucc: Boolean;

  protected
    procedure Execute; override;
  end;

{ TINFThread }

procedure TINFThread.Execute;
var
  L: LongWord;

begin
  L := MAX_PATH + 23;
  tFN := StringOfChar(#0, L);
  bSucc := SetupCopyOEMInf(@sFN[1], nil, 1, 0, @tFN[1], L, @L, nil);
  sFN := '';
  if not bSucc then Exit;

  if L > 0 then begin
    Dec(L);
    if L < LongWord(Length(tFN)) then SetLength(tFN, L);
  end;
end;

function PreloadCystINF(INFPath, CoNick: String): Boolean;
var
  Reg: TRegistry;
  INFThread: TINFThread;

begin
  if not bCystAvailable then begin
    Result := False;
    Exit;
  end;

  INFThread := TINFThread.Create(True);
  INFThread.FreeOnTerminate := False;
  INFThread.sFN := INFPath;
  INFThread.Resume;

  Application.ProcessMessages;
  while WaitForSingleObject(INFThread.Handle, 0) = WAIT_TIMEOUT do begin
    Sleep(1);
    Application.ProcessMessages;
  end;

  if not INFThread.bSucc then begin
    INFThread.Free;
    Result := False;
    Exit;
  end;

  Reg := TRegistry.Create(KEY_ALL_ACCESS);//KEY_CREATE_SUB_KEY or KEY_SET_VALUE);
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  Reg.OpenKey('Software\' + CoNick + '\INF', True);
  Reg.WriteString(INFPath, ExtractFileName(INFThread.tFN));
  Reg.Free;
  INFThread.Free;
  Result := True;
end;





initialization
  hSetupAPI := LoadLibrary('SetupAPI.dll');
  try
    SetupCopyOEMInf := TLFSetupCopyOEMInf(GetProcAddress(hSetupAPI, 'SetupCopyOEMInfA'));
  except
    SetupCopyOEMInf := nil;
  end;
  bCystAvailable := Assigned(SetupCopyOEMInf);

finalization
  FreeLibrary(hSetupAPI);

end.