{$define ACCES}
{//$define Kontron}
{//$define ADL}
unit InstallerForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, jpeg, ExtCtrls, ComCtrls, ShellAPI, IniFiles, Registry,
  FileCtrl, ShlObj, Comobj, Ole2, ScktComp;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    HintMemo: TMemo;
    Page: TPageControl;
    MainSheet: TTabSheet;
    DesignTimeLabel: TLabel;
    SelectSheet: TTabSheet;
    InstructionLabel1: TLabel;
    TypeCombo: TComboBox;
    ListPanel: TPanel;
    ProdList: TListBox;
    ProductFilter: TEdit;
    FinishedSheet: TTabSheet;
    DoneMemo: TMemo;
    Panel4: TPanel;
    RunPCIFIND: TButton;
    Finish: TButton;
    Upgrade2Button: TButton;
    UpgradeButton: TButton;
    LVCheck: TCheckBox;
    CancelButton: TButton;
    Label2: TLabel;
    PPath: TPanel;
    DestChangeButton: TButton;
    InstallButton: TButton;
    WaitLabel: TLabel;
    SetupButton: TButton;
    NetButton: TBitBtn;
    InstructionLabel3: TLabel;
    Label3: TLabel;
    ProductName: TPanel;
    InstructionLabel0: TLabel;
    InstructionLabel2: TLabel;
    ProgSheet: TTabSheet;
    CopyCheckLabel: TLabel;
    CopyLabel: TLabel;
    RegisterCheckLabel: TLabel;
    RegisterLabel: TLabel;
    procedure UpgradeButtonClick(Sender: TObject);
    procedure RunPCIFINDClick(Sender: TObject);
    procedure FinishClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TypeComboChange(Sender: TObject);
    procedure ProductFilterChange(Sender: TObject);
    procedure ProdListClick(Sender: TObject);
    procedure SelectSheetEnter(Sender: TObject);
    procedure MainSheetEnter(Sender: TObject);
    procedure ViewSheetEnter(Sender: TObject);
    procedure FinishedSheetEnter(Sender: TObject);
    //procedure ProductFilterKeyPress(Sender: TObject; var Key: Char);
    procedure InstallButtonClick(Sender: TObject);
    procedure DestChangeButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SetupButtonClick(Sender: TObject);
    procedure NetButtonClick(Sender: TObject);
    procedure ClientSockConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSockDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSockRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSockError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
    SourcePath, CardName, PackageName, WindowsDrive: String;
    ToFileList, FromFileList: String;
    DriverPath, DLL32Path, DLL64Path, LVPath, WindowsPath, StartProgramsPath, ProgramFilesPath, SPTPath, CystPath, TempPath: String;
    ToFiles: TStringList;
    FileLog: TIniFile;
    DisksIni: TMemIniFile;
    bCyst,
    bNT, bSeven, b64: Boolean;
    LVInstalled: Boolean;
    URL: String;
    FileValues, FriendlyValues, PackageValues, PvPValues, LineProducts: TStringList;
    procedure AddDrivers(bVXD: Boolean);
    procedure AddLV(DriverExt: String);
    procedure InstallStartMenuGroup(ObjectPath, Root, Title, Desc: string);
    procedure CreateShellLink(sPathObj, sPathLink, sDesc : string);
    procedure AddFile(SRCFilePath, DSTFilePath: String; bCheckIfExists: Boolean = False);
    procedure SetupUninstall;
    procedure CopyINFFromCD(Nom: String);
    procedure AddStartMenu(BasePath, GroupName: String);
  public
    { Public declarations }
    procedure DisplayHint(Sender:TObject);
  end;

var
  MainForm: TMainForm;

implementation

uses
  {$ifdef ACCES}
    //DLUnit,
    ACCESID,
  {$endif}
  {$ifdef Kontron}
    KontronID,
  {$endif}
  {$ifdef ADL}
    ADLID,
  {$endif}
  ChangeDestFormu, CystINFs;

{$R *.DFM}

function IsOS(dwOS: DWord): Bool; stdcall; external 'Shlwapi.dll' index 437;

const
   OS_WOW6432 = 30;
   DISKINI = '\disks.ini';
   WinReadMe = '\INSTALL.TXT';
   LVKey = 'Software\National Instruments\LabVIEW\CurrentVersion';
   UninstallKey = 'Software\Microsoft\Windows\CurrentVersion\Uninstall\' + CoNick + ' Data Acquisition';
   CSIDL_PROGRAM_FILES = $0026;
   CSIDL_SYSTEMX86     = $0029;

var
  RecStr: String;

procedure DisableRedirectionIfAny;
type
  PPointer = ^Pointer;
  TWow64DisableWow64FsRedirection = function (OldValue: PPointer): BOOL; stdcall;

var
  Wow64DisableWow64FsRedirection: TWow64DisableWow64FsRedirection;
  hLib: THandle;
  OldRedirection: Pointer;

begin
  hLib := LoadLibrary('Kernel32.dll');
  if hLib = 0 then Exit; //Dunno what happened there...
  Wow64DisableWow64FsRedirection := GetProcAddress(hLib, 'Wow64DisableWow64FsRedirection');
  if Assigned(Wow64DisableWow64FsRedirection) then Wow64DisableWow64FsRedirection(@OldRedirection);
  //FreeLibrary(hLib);
end;

procedure TMainForm.DisplayHint(Sender:TObject);
begin
   HintMemo.Lines.Clear;
   HintMemo.Lines.Append(GetLongHint(Application.Hint));
end;

procedure TMainForm.UpgradeButtonClick(Sender: TObject);
var
  UpgradePath: String;
begin
   UpgradePath := IncludeTrailingBackslash(PPath.Caption) + 'Upgrade.exe';
   if WinExec(PChar(UpgradePath), SW_SHOWNORMAL) < 32 then
      Application.MessageBox(PChar('Could not find ' + UpgradePath), 'Error', MB_ICONSTOP);
end;

procedure TMainForm.RunPCIFINDClick(Sender: TObject);
begin
   winexec('PCIFIND.EXE',SW_NORMAL);
end;

procedure TMainForm.FinishClick(Sender: TObject);
begin
   Close;
end;

procedure TMainForm.CancelButtonClick(Sender: TObject);
begin
   Close;
end;

function GetWinDir: String;
var
  L: Integer;

begin
  SetString(Result, nil, MAX_PATH);
  L := GetWindowsDirectory(@Result[1], Length(Result));
  SetLength(Result, L);
end;

function GetSysDir: String;
var
  L: Integer;

begin
  SetString(Result, nil, MAX_PATH);
  L := GetSystemDirectory(@Result[1], Length(Result));
  SetLength(Result, L);
end;

function GetTempDir: String;
var
  L: LongWord;
  
begin
  SetString(Result, nil, MAX_PATH + 1);
  L := GetTempPath(MAX_PATH, @Result[1]);
  SetLength(Result, L);
end;

procedure TMainForm.FormCreate(Sender: TObject);

  function GetCSIDLPath(CSIDL: Integer): String;
  var
    I: Integer;

  begin
    SetLength(Result, MAX_PATH + 1);
    if SHGetSpecialFolderPath(Application.Handle, @Result[1], CSIDL, False) then begin
      for I := 1 to Length(Result) do
        if Result[I] = #0 then begin
          SetLength(Result, I - 1);
          Break;
        end
      ;
    end
    else begin
      Result := '';
    end;
  end;

var
   Reg: TRegistry;
   i: Integer;
   //TempClient: TClientSocket;
   SystemPath: String;
   V: OSVERSIONINFO;

begin
   DisableRedirectionIfAny;

   //WebBtn.Caption := 'Go To ' + CoNick + ' &Website';
   Caption := CoNick + ' CD-Installer - Windows';
   SourcePath := IncludeTrailingBackslash(ExtractFilePath(Application.EXEName));
   for I := 1 to ParamCount do if UpperCase(ParamStr(I)) = '/CDA' then SourcePath := 'O:\CD\CDA\';
   Application.OnHint := DisplayHint;
   for I := 0 to Page.PageCount - 1 do Page.Pages[I].TabVisible := False;
   //Page.ActivePage := MainSheet;
   Page.ActivePage := SelectSheet;
   with InstructionLabel0.Font do Style := Style + [fsBold];
   with InstructionLabel1.Font do Style := Style + [fsBold];
   with InstructionLabel2.Font do Style := Style + [fsBold];
   with InstructionLabel3.Font do Style := Style + [fsBold];
   with CopyCheckLabel.Font do begin
     Size := 3 * Size;
     Name := 'Wingdings';
   end;
   with RegisterCheckLabel.Font do begin
     Size := 3 * Size;
     Name := 'Wingdings';
   end;
   ToFiles := TStringList.Create;

   DisksIni := TMemIniFile.Create(SourcePath + 'Disks' + DISKINI);

   LineProducts := TStringList.Create;
   PvPValues := TStringList.Create;
   PackageValues := TStringList.Create;
   FileValues := TStringList.Create;
   FriendlyValues := TStringList.Create;

   URL := DisksIni.ReadString('Localization', 'CompanyURL', 'Error #1: R-Value Not Found');

   DisksIni.ReadSection('Files', FileValues);
   DisksIni.ReadSection('Packages', PackageValues);         //consider toupper
   DisksIni.ReadSection('productsVSpackages(ALL)', PvPValues);
   for i := 0 to FileValues.Count - 1 do begin
      FriendlyValues.Add(DisksIni.ReadString('FriendlyNames', FileValues[i], ''));
      if FriendlyValues[i] <> '' then TypeCombo.Items.Add(FriendlyValues[i]);
   end;
   TypeCombo.ItemIndex := 0;
   TypeCombo.OnChange(TypeCombo);



  V.dwOSVersionInfoSize := sizeof(V);
  GetVersionEx(V);
  bNT := V.dwPlatformId = VER_PLATFORM_WIN32_NT;
  if bNT then begin
    bSeven := V.dwMajorVersion >= 6;
    b64 := IsOS(OS_WOW6432);
  end
  else begin
    bSeven := False;
    b64 := False;
  end;

  WindowsPath := IncludeTrailingBackslash(GetWinDir);
  WindowsDrive := Copy(WindowsPath, 1, 3);
  SystemPath := IncludeTrailingBackslash(GetSysDir);
  TempPath := IncludeTrailingBackslash(GetTempDir);
  ProgramFilesPath := IncludeTrailingBackslash(GetCSIDLPath(CSIDL_PROGRAM_FILES));
  CystPath := ProgramFilesPath + CoNick + '\Common Drivers\';
  SPTPath := WindowsPath + 'System32\AIOSPT\';
  if bNT then begin
    StartProgramsPath := IncludeTrailingBackslash(GetCSIDLPath(CSIDL_COMMON_PROGRAMS));
    DriverPath := SystemPath + 'Drivers\';
  end
  else begin
    StartProgramsPath := IncludeTrailingBackslash(GetCSIDLPath(CSIDL_PROGRAMS));
    DriverPath := SystemPath;
  end;
  if b64 then begin
    DLL32Path := IncludeTrailingBackslash(GetCSIDLPath(CSIDL_SYSTEMX86));
    DLL64Path := SystemPath;
  end
  else begin
    DLL32Path := SystemPath;
    DLL64Path := '';
  end;

  bCyst := bNT and bCystAvailable;



   Reg := TRegistry.Create;
   Reg.RootKey := HKEY_LOCAL_MACHINE;
   if Reg.OpenKey(LVKey, false) then begin
      LVPath := IncludeTrailingBackslash(Reg.ReadString('Path')) + 'user.lib\';
      LVInstalled := true;
      Reg.CloseKey;
   end
   else
      LVInstalled := false;
   Reg.Free;

   PPath.Caption := ProgramFilesPath + CoNick + '\';

   (*
   {$IFDEF ACCES}
      if Now - FileDateToDateTime(FileAge(Application.ExeName)) > 243.495 then begin//eight months
        try
          TempClient := TClientSocket.Create(Self);
          TempClient.ClientType := ctNonBlocking;
          TempClient.Host := CoHost;
          TempClient.Port := 80;
          TempClient.OnConnect := ClientSockConnect;
          TempClient.OnRead := ClientSockRead;
          TempClient.OnDisconnect := ClientSockDisconnect;
          TempClient.OnError := ClientSockError;
          TempClient.Open;
        except
        end;
      end;
   {$ENDIF}
   *)
end;

procedure TMainForm.TypeComboChange(Sender: TObject);
var
   i, j: Integer;
   ThisProductLine, TheseFiles, ThisPackage, ThatPackage, ThisProduct: String;
begin
   WaitLabel.Visible := True;
   WaitLabel.Repaint;
   LineProducts.Clear;
   ProdList.Items.Clear;
   ProductFilter.Text := '';
   if TypeCombo.ItemIndex = 0 then begin
      ThisProductLine := PvPValues.Text;
      ProdList.Items.Text := ThisProductLine;
      LineProducts.Text := ThisProductLine;
   end
   else begin
      ThisProductLine := FileValues[FriendlyValues.IndexOf(TypeCombo.Text)];
      ThisProductLine := ',' + ThisProductLine + ',';
      for i := 0 to PackageValues.Count - 1 do begin
         ThisPackage := PackageValues[i];
         TheseFiles := ',' + DisksIni.ReadString('Packages', ThisPackage, 'Error #3: R-Value Not Found') + ',';
         if Pos(ThisProductLine, TheseFiles) <> 0 then begin
            ThisPackage := UpperCase(ThisPackage);
            for j := 0 to PvPValues.Count - 1 do begin
               ThatPackage := PvPValues[j];
               ThisProduct := DisksIni.ReadString('productsVSpackages(ALL)', ThatPackage, 'Error #4: R-Value Not Found');
               if UpperCase(ThisProduct) = ThisPackage then begin
                  ProdList.Items.Add(ThatPackage);
                  LineProducts.Add(ThatPackage);
               end;
            end;  //  end for
         end;  //  end if
      end;  //  end for
   end;
   WaitLabel.Visible := False;
end;  //  end TypeComboChange

procedure TMainForm.ProductFilterChange(Sender: TObject);
var
   i: Integer;
   NewFilter: String;

begin
   NewFilter := UpperCase(ProductFilter.Text);
   if NewFilter = '' then begin
     ProdList.Items.Text := LineProducts.Text;
   end
   else begin
     ProdList.Items.Clear;
     for i := 0 to LineProducts.Count - 1 do begin
       if Pos(NewFilter, UpperCase(LineProducts[i])) <> 0 then begin
          ProdList.Items.Add(LineProducts[i]);
       end;  //  end if
     end;  //  end for
   end;
   if ProdList.Items.Count = 0 then begin
      InstallButton.Enabled := False;
      ProductName.Caption := '';
      PackageName := '';
      LVCheck.Enabled := False;
      LVCheck.Checked := False;
      PPath.Caption := ProgramFilesPath + CoNick + '\';
   end
   else begin
     ProdList.ItemIndex := 0;
     ProdList.OnClick(ProdList);
   end;
end;  //  end ProductFilterChange

procedure TMainForm.ProdListClick(Sender: TObject);
var
   TheseFiles: String;
begin
   ProductName.Caption := ProdList.Items[ProdList.ItemIndex];
   PackageName := DisksIni.ReadString('productsVSpackages(ALL)', ProductName.Caption, 'Error #5: R-Value Not Found');
   TheseFiles := DisksIni.ReadString('Packages', PackageName, 'Error #6: R-Value Not Found');
   if (Pos('lv', TheseFiles) <> 0) and LVInstalled then begin
      if not LVCheck.Enabled then begin
         LVCheck.Enabled := True;
         LVCheck.Checked := True;
      end;
   end
   else begin
      LVCheck.Enabled := False;
      LVCheck.Checked := False;
   end;
   PPath.Caption := ProgramFilesPath + CoNick + '\' + PackageName;
   InstallButton.Enabled := True;
   ProdList.ItemIndex := ProdList.Items.IndexOf(ProductName.Caption);
end;

procedure TMainForm.SelectSheetEnter(Sender: TObject);
begin
   MainForm.Hint:='Select the product you wish to install from the list, then click Next.';
end;

procedure TMainForm.MainSheetEnter(Sender: TObject);
begin
   MainForm.Hint:=CoName + #13+#10 + 'CD Installer' + #13+#10 + 'Please select a button to begin.';
end;

procedure TMainForm.ViewSheetEnter(Sender: TObject);
begin
   MainForm.Hint := 'Click OK to return to the main install menu.';
end;

procedure TMainForm.FinishedSheetEnter(Sender: TObject);
begin
end;

////Replaced with CharCase property.
//procedure TMainForm.ProductFilterKeyPress(Sender: TObject; var Key: Char);
//begin
//   Key := UpCase(Key);
//end;

procedure DumpStringToFile(S, Path: String);
var
  Fil: TFileStream;

begin
  Fil := TFileStream.Create(Path, fmCreate or fmShareDenyWrite);
  try
    Fil.Write(S[1], Length(S));
  finally
    Fil.Free;
  end;
end;

function DumpFileToString(Path: String): String;
var
  Fil: TFileStream;
  L: Integer;

begin
  Fil := TFileStream.Create(Path, fmOpenRead or fmShareDenyWrite);
  try
    L := Fil.Size;
    SetString(Result, nil, L);
    Fil.Read(Result[1], L);
  finally
    Fil.Free;
  end;
end;

{
procedure VerifyFiles(FileList: String);
var
  I, J: Integer;
  ThisFile: String;

begin
  repeat
    J := 0;
    for I := 1 to Length(FileList) do
      if FileList[I] = #0 then begin
        J := I;
        Break;
      end
    ;
    if J = 0 then Exit;
    ThisFile := Copy(FileList, 1, J - 1);
    FileList := Copy(FileList, J + 1, MAXINT);

    if not FileExists(ThisFile) then
      Application.MessageBox(
        PChar('"' + ThisFile + '" does not exist.'),
        'File Not Found', MB_ICONEXCLAMATION
      )
    ;
  until False;
end;
}

procedure TMainForm.AddFile(SRCFilePath, DSTFilePath: String; bCheckIfExists: Boolean = False);
begin
  if bCheckIfExists then
    if not FileExists(SRCFilePath) then Exit
  ;

  FileLog.WriteString(
    CoNick + ' File Log - ' + PackageName,
    SRCFilePath,
    DSTFilePath + ',' + IntToStr(FileAge(SRCFilePath))
  );
  FromFileList := FromFileList + SRCFilePath + #0;
  ToFileList := ToFileList + DSTFilePath + #0;
  ToFiles.Add(DSTFilePath);
end;

procedure TMainForm.CopyINFFromCD(Nom: String);
var
  TempINF, OEMINF: String;
  INFContent: TStringList;
  I: Integer;
  Buf: String;

{$J+}
const
  J: Integer = -1;
{$J-}

begin
  TempINF := TempPath + Nom;
  INFContent := TStringList.Create;
  INFContent.Text := DumpFileToString(SourcePath + Nom);
  for I := INFContent.Count - 1 downto 0 do begin
    Buf := UpperCase(Trim(INFContent.Names[I]));
    if (Buf = 'CATALOGFILE') or (Buf = 'COPYFILES') then
      INFContent.Delete(I)
    ;
  end;
  DumpStringToFile(INFContent.Text, TempINF);
  INFContent.Free;

  if bNT then begin
    repeat
      Inc(J);
      OEMINF := WindowsPath + 'INF\oem' + IntToStr(J) + '.inf';
    until not FileExists(OEMINF);
    CopyFile(PChar(TempINF), PChar(OEMINF), True);
    SetFileAttributes(PChar(OEMINF), 0);
  end
  else begin
    CopyFile(PChar(TempINF), PChar(WindowsPath + 'INF\Other\' + Nom), True);
    SetFileAttributes(PChar(WindowsPath + 'INF\Other\' + Nom), 0);
  end;
  DeleteFile(TempINF);
end;

procedure TMainForm.AddStartMenu(BasePath, GroupName: String);
var
   SubSR: TSearchRec;

begin
  if FindFirst(BasePath + '*.*', faDirectory, SubSR) = 0 then begin
    repeat
      if SubSR.Name[1] <> '.' then
        InstallStartMenuGroup(BasePath + SubSR.Name, IncludeTrailingBackslash(CoNick + ' ' + CardName) + GroupName, SubSR.Name, '')
      ;
    until FindNext(SubSR) <> 0;  //  end repeat until
  end;  //  end if FindFirst
  FindClose(SubSR);
end;  //  end AddStartMenu

procedure TMainForm.InstallButtonClick(Sender: TObject);

  procedure AddFiles(SearchPath, BasePath: String);
  var
    Findee: TSearchRec;

  begin
    if FindFirst(SearchPath + '*.*', faAnyFile, Findee) = 0 then begin
      repeat
        if (Findee.Attr and faDirectory) = 0 then begin
          AddFile(SearchPath + Findee.Name, BasePath + Findee.Name);
        end  //  end if Findee.Attr
        else begin
          if Findee.Name[1] <> '.' then
            if (UpperCase(Findee.Name) <> 'LABVIEW') or ((UpperCase(Findee.Name) = 'LABVIEW') and LVInstalled and LVCheck.Checked) then
              AddFiles(IncludeTrailingBackslash(SearchPath + Findee.Name), BasePath + Findee.Name + '\')
          ;
        end;  //  end else
      until FindNext(Findee) <> 0;  //  end repeat
      FindClose(Findee);
    end;
  end;  //  end AddFiles procedure

var
  Error, I, P, D: Integer;
  SR: TSearchRec;
  MySHfile: TSHFileOpStruct;
  InstallPath, SRExt: String;
  PackageReg: TRegIniFile;
  PackageTypes, PackageDirs, Buf: TStringList;
  bAOK: Boolean;

begin
   HintMemo.Lines.Clear;
   HintMemo.Repaint;
   InstallButton.Enabled := False;
   CancelButton.Enabled := False;
   CopyCheckLabel.Font.Color := $FF0000;
   CopyCheckLabel.Caption := '';
   RegisterCheckLabel.Visible := bCyst;
   RegisterLabel.Visible := bCyst;
   Page.ActivePage := ProgSheet;
   ProgSheet.Repaint;

   PackageReg := TRegIniFile.Create;
   InstallPath := IncludeTrailingBackslash(PPath.Caption);
   CardName := ProductName.Caption;

   FileLog := TIniFile.Create(InstallPath + 'FileLog.ini');
   PackageReg.RootKey := HKEY_LOCAL_MACHINE;
   if PackageReg.OpenKey('Software\' + IncludeTrailingBackslash(CoNick), True) then begin
      PackageReg.WriteString('Installed Packages', DateTimeToStr(Now), PackageName + ',' + InstallPath);
      PackageReg.Free;
   end;  //  end if

   try
     ForceDirectories(InstallPath);
   except
   end;

    if bNT then begin
       AddDrivers(False);
       if LVCheck.Checked then
          AddLV('.SYS');
    end
    else begin
       AddDrivers(True);
       if LVCheck.Checked then
          AddLV('.VXD')
       ;
    end;

   //AddFiles(SourcePath + 'DISKS\' + PackageName + '\', InstallPath);
   //AddFiles(SourcePath + 'DISKS\TOOLS\', InstallPath);
   //AddFiles(SourcePath + 'DISKS\TOOLS.WIN\', InstallPath);

   //This is the actual intelligent Tools packages stuff
   PackageTypes := TStringList.Create;
   PackageDirs := TStringList.Create;
   Buf := TStringList.Create;
   PackageTypes.Text := StringReplace(DisksIni.ReadString('Packages', PackageName, 'DEFAULT'), ',', #13, [rfReplaceAll]);
   for P := 0 to PackageTypes.Count - 1 do
     if UpperCase(PackageTypes[P]) = 'DEFAULT' then begin
       PackageDirs.Values[SourcePath + 'DISKS\' + PackageName] := 'True';
       PackageDirs.Values[SourcePath + 'DISKS\TOOLS'] := 'True';
       PackageDirs.Values[SourcePath + 'DISKS\TOOLS.WIN'] := 'True';
     end
     else if bCyst and (UpperCase(PackageTypes[P]) = 'PTLDRV') then begin
       AddFiles(SourcePath + 'Drivers\PTL\', CystPath);
     end
     else begin
       Buf.Text := StringReplace(DisksIni.ReadString('Files', PackageTypes[P], ''), ',', #13, [rfReplaceAll]);
       for D := 0 to Buf.Count - 1 do
         PackageDirs.Values[SourcePath + 'DISKS\' + Buf[D]] := 'True'
       ;
       if (UpperCase(PackageTypes[P]) = 'PCI') then begin
         if bSeven or b64 then
           InstallStartMenuGroup(WindowsPath + 'AIOWDMFind.exe', CoNick + ' ' + CardName, 'AIOWDMFind', '')
         else
           InstallStartMenuGroup(WindowsPath + 'PCIFind.exe', CoNick + ' ' + CardName, 'PCIFind', '')
         ;
       end;
     end
   ;
   PackageTypes.Free;
   Buf.Free;

   for D := PackageDirs.Count - 1 downto 0 do
     if DirectoryExists(PackageDirs.Names[D]) then
       AddFiles(IncludeTrailingBackslash(PackageDirs.Names[D]), InstallPath)
   ;
   PackageDirs.Free;

   with MySHfile do begin
      fAnyOperationsAborted := false;

      fFlags := FOF_MULTIDESTFILES or FOF_NOCONFIRMMKDIR or FOF_NOCONFIRMATION;

      Wnd := Handle;
      wFunc := FO_COPY;
      pFrom := PChar(FromFileList + #0);
      pTo := PChar(ToFileList + #0);
      //VerifyFiles(FromFileList);
   end;  //  end with MySHFile
   Error := SHFileOperation(MySHfile);

   if Error = 0 then begin
      for i := 0 to ToFiles.Count - 1 do
         SetFileAttributes(PChar(ToFiles[i]), FILE_ATTRIBUTE_NORMAL);
      if not bNT then begin
         //InstallStartMenuGroup(InstallPath + 'riscterm.exe', CoNick + ' ' + CardName, 'RISCTerm', '');
         if FileExists(InstallPath + 'findbase.exe') then
            InstallStartMenuGroup(InstallPath + 'findbase.exe', CoNick + ' ' + CardName, 'FindBase-ISA', '');
      end;  //  end if not NT

      if FindFirst(InstallPath + '*.*', faAnyFile, SR) = 0 then repeat
         if SR.Name[1] = '.' then
            //Ignore virtual dirs.
         else if SR.Attr and faDirectory <> 0 then begin
            if UpperCase(SR.Name) = 'DOS' then
               AddStartMenu(InstallPath + SR.Name + '\', 'DOS Samples')
            else if UpperCase(SR.Name) = 'WIN32' then
               AddStartMenu(InstallPath + SR.Name + '\', 'Windows Samples')
            else if UpperCase(SR.Name) = 'WIN16' then
               AddStartMenu(InstallPath + SR.Name + '\', 'Windows 16bit Samples')
            else if UpperCase(SR.Name) = 'LABVIEW' then
               AddStartMenu(InstallPath + SR.Name + '\', 'LabView Samples')
            else
               InstallStartMenuGroup(InstallPath + SR.Name, CoNick + ' ' + CardName, SR.Name, '');
         end  //  end if SR.Attr
         else if SR.Name[1] = '_' then
            break
         else begin
           SRExt := UpperCase(ExtractFileExt(SR.Name));
           if SRExt = '.PDF' then
             InstallStartMenuGroup(InstallPath + SR.Name, CoNick + ' ' + CardName, Copy(SR.Name, 1, Length(SR.Name) - Length(ExtractFileExt(SR.Name))) + ' Manual (.PDF)', '')
           else if SRExt = '.EXE' then begin
             if UpperCase(SR.Name) = 'SETUP.EXE' then
               InstallStartMenuGroup(InstallPath + SR.Name, CoNick + ' ' + CardName, 'Settings', '')
             else
               InstallStartMenuGroup(InstallPath + SR.Name, CoNick + ' ' + CardName, ExtractFileName(SR.Name), '')
             ;
           end
           else if SRExt = '.TXT' then
             InstallStartMenuGroup(InstallPath + SR.Name, CoNick + ' ' + CardName, SR.Name, '')
           else if (SRExt = '.HTML') or (SRExt = '.HTM') then begin
             if SR.Name = 'weblink.html' then
               InstallStartMenuGroup(InstallPath + 'weblink.html', CoNick + ' ' + CardName, CoNick+' Web Site', '')
             else
               InstallStartMenuGroup(InstallPath + SR.Name, CoNick + ' ' + CardName, SR.Name, '')
             ;
           end;
         end;
      until FindNext(SR) <> 0;
      FindClose(SR);
   end;  //  end if Error = 0

   MainForm.FileLog.WriteString(
     'START',
     CoNick + ' File Log - ' + PackageName,
     IncludeTrailingBackslash(StartProgramsPath + CoNick + ' ' + CardName)
   );

   SetupUninstall;

   if not (bSeven or b64) then WinExec(PChar(WindowsPath + 'PCIFind.exe /ns'), SW_HIDE);

   if MySHfile.fAnyOperationsAborted then begin
     CopyCheckLabel.Font.Color := $0000FF;
     CopyCheckLabel.Caption := '';
     CopyCheckLabel.Repaint;
     Hide;
     Application.MessageBox('An error occurred while copying files. Installation is incomplete. Please close any open programs and run this install program again.', 'File Copy Error', MB_ICONEXCLAMATION);
     Close;
   end
   else begin
     CopyCheckLabel.Font.Color := $00FF00;
     CopyCheckLabel.Caption := '';
     CopyCheckLabel.Repaint;

     if bCyst then begin
       RegisterCheckLabel.Font.Color := $FF0000;
       RegisterCheckLabel.Caption := '';
       RegisterCheckLabel.Repaint;

       Buf := TStringList.Create;
       if FindFirst(CystPath + '*.inf', faAnyFile, SR) = 0 then repeat
         Buf.Add(SR.Name);
       until FindNext(SR) <> 0;
       FindClose(SR);

       bAOK := True;
       for I := 0 to Buf.Count - 1 do begin
         RegisterLabel.Caption := 'Registering .INFs (' + IntToStr(I + 1) + '/' + IntToStr(Buf.Count) + ')';
         if not PreloadCystINF(CystPath + Buf[I], CoNick) then bAOK := False;
       end;
       Buf.Free;

       if bAOK then begin
         RegisterCheckLabel.Font.Color := $00FF00;
         RegisterCheckLabel.Caption := '';
         RegisterCheckLabel.Repaint;
       end
       else begin
         RegisterCheckLabel.Font.Color := $0000FF;
         RegisterCheckLabel.Caption := '';
         RegisterCheckLabel.Repaint;
       end;
     end;

     //Set up FinishedSheet.
     DoneMemo.Lines.Clear;
     DoneMemo.Lines.Append('Installation and copy of files is complete. Your ' + CardName + ' is now ready for use.'#13#10);
     
     if (Pos('PCI', CardName) <> 0) or ('P104' = Copy(CardName, 1, 4)) then begin
       if bSeven or b64 then begin
         WinExec(PChar(WindowsPath + 'AIOWDMFind.exe'), SW_HIDE);
         RunPciFind.Enabled := False;
       end
       else begin
         DoneMemo.Lines.Append('You have installed the software package for a PCI card. It is recommended that you run PCIFIND.EXE to setup the registry for your card before you attempt to use it. '
                             + 'After running PCIFIND.EXE, you can use the card or samples. If your card is already in the computer, click RUN PCIFIND now.'#13#10
         );
         RunPciFind.Enabled := True;
       end
     end
     else begin
       RunPciFind.Enabled := False;
     end;
     RunPciFind.Visible := not (bSeven or b64);

     DoneMemo.Lines.Append('We recommend that you run the settings program for your card at this time. Please click the "Settings..." button, below. '
                         + 'This will allow you to configure jumpers and options for using your card. '
                         + 'If you have already installed the card, you might need to remove it to set some options.'#13#10
     );

     if LVCheck.Checked then
        DoneMemo.Lines.Append('A LabVIEW driver and sample(s) have been installed. To run a sample, open LabVIEW and browse to [install directory]\LabVIEW\Samples. '
                            + '(For example, if you installed the ' + CoNick + ' software to the C:\PCID48S directory, browse to C:\PCID48S\LabVIEW\Samples.) '
                            + 'Open the Sample.vi file or one of the Sample#.vi files there.');

     (*
     {$ifdef ACCES}
        DoneMemo.Lines.Append('We also recommend that you check for updates to the software with our Update utility. This utility will connect to ACCES''s FTP site and download the latest version of our software. '
                            + 'Please click the "Find Upgrades" button, below.');
     {$else}
        Upgrade2Button.Visible := False;
     {$endif}
     *)
     MainForm.Hint := 'FINISHED!';

     Page.ActivePage := FinishedSheet;
   end;
end;  //  end InstallButtonClick



procedure TMainForm.AddDrivers(bVXD: Boolean);

  procedure CopyCystFile(SubFilePath: String; bCheckIfExists: Boolean = False);
  var
    SrcPath, DstPath: String;

  begin
    SrcPath := SourcePath + SubFilePath;
    DstPath := CystPath + SubFilePath;
    if bCheckIfExists then
      if not FileExists(SrcPath) then Exit
    ;

    ForceDirectories(ExtractFilePath(DstPath));
    CopyFile(PChar(SrcPath), PChar(DstPath), False);
    SetFileAttributes(PChar(DstPath), FILE_ATTRIBUTE_ARCHIVE);
    SrcPath := '';
    DstPath := '';
  end;

  procedure CopyCystFiles(SubSearchPath, SearchExt: String);
  var
     Findee: TSearchRec;

  begin
    if FindFirst(SourcePath + SubSearchPath + SearchExt, faAnyFile and not faDirectory, Findee) = 0 then begin
      repeat
        CopyCystFile(SubSearchPath + Findee.Name);
      until FindNext(Findee) <> 0;
      FindClose(Findee);
    end;  //  end if
  end;

  procedure AddDriverFiles(SearchPath, SearchExt, BasePath: String; bCheckCystSys: Boolean = False);
  var
     Findee: TSearchRec;
     uNom: String;

  begin
    if FindFirst(SearchPath + SearchExt, faAnyFile and not faDirectory, Findee) = 0 then begin
      repeat
        if bCheckCystSys then
          uNom := UpperCase(Findee.Name);
          if (uNom = 'AIO16.SYS')
          or (uNom = 'W2KPDD.SYS')
          //or (uNom = 'AIOUSB.SYS')
          //or (uNom = 'PCI8S.SYS')
          then begin
            CopyCystFile('Drivers\' + Findee.Name);

            Continue;
          end
        ;

        AddFile(SearchPath + Findee.Name, BasePath + Findee.Name);
      until FindNext(Findee) <> 0;
      FindClose(Findee);
    end;  //  end if
  end;

begin
  //SetCurrentDir(ExcludeTrailingBackslash(SourcePath));

  if bCyst then begin
    CopyCystFile(CoINF);
    CopyCystFile(ChangeFileExt(CoINF, '.cat'));
    CopyCystFile('AIOCyUSB.inf', True);
    CopyCystFile('AIOWinUSB.inf', True);
    CopyCystFile('Ports.inf');
  end
  else begin
    CopyINFFromCD(CoINF);
    CopyINFFromCD('AIOCyUSB.inf');
    CopyINFFromCD('Ports.inf');
  end;

  AddFile(SourcePath + 'Drivers\PCIFind.exe', WindowsPath + 'PCIFind.exe', True);
  AddFile(SourcePath + 'Drivers\AIOWDMFind.exe', WindowsPath + 'AIOWDMFind.exe', True);
  AddFile(SourcePath + 'Drivers\Uninstall.exe', WindowsPath + CoNick + 'Uninstall.exe', True);
  //AddFiles(SourcePath + 'drivers\', '*.exe', WindowsPath);
  AddDriverFiles(SourcePath + 'Drivers\', '*.dll', DLL32Path);
  if b64 then AddDriverFiles(SourcePath + 'Drivers\DLL.64\', '*.dll', DLL64Path);
  if bVXD then AddDriverFiles(SourcePath + 'drivers\', '*.vxd', DriverPath);

  if bCyst then begin
    AddDriverFiles(SourcePath + 'Drivers\', '*.sys', DriverPath, True);
    CopyCystFiles('Drivers\NT64\', '*.*');
    CopyCystFiles('Drivers\NT32\', '*.*');
    CopyCystFiles('Drivers\SPT\' , '*.*');
  end
  else begin
    AddDriverFiles(SourcePath + 'Drivers\', '*.sys', DriverPath, False);
    if b64 then begin
      AddDriverFiles(SourcePath + 'Drivers\NT64\', '*.dll', DLL64Path);
      AddDriverFiles(SourcePath + 'Drivers\NT64\', '*.sys', DriverPath);
    end
    else begin
      AddDriverFiles(SourcePath + 'Drivers\NT32\', '*.dll', DLL32Path);
      AddDriverFiles(SourcePath + 'Drivers\NT32\', '*.sys', DriverPath);
    end;
    AddDriverFiles(SourcePath + 'Drivers\SPT\', '*.spt', SPTPath);
  end;
end;

procedure TMainForm.AddLV(DriverExt: String);

   procedure AddLVFiles(SearchPath, BasePath: String);
   var
      SubFindee: TSearchRec;

   begin
      FindFirst(SearchPath + '*.*', faAnyFile, SubFindee);
      repeat
         if (SubFindee.Attr and faDirectory) = 0 then begin
            FileLog.WriteString(CoNick + ' File Log - ' + PackageName, ExtractFilePath(SearchPath) + SubFindee.Name, IncludeTrailingBackslash(BasePath) + SubFindee.Name + ',' + IntToStr(FileAge(SearchPath + SubFindee.Name)));//SubFileFormatDate);
            FromFileList := FromFileList + SearchPath + SubFindee.Name + #0;
            ToFileList := ToFileList + BasePath + SubFindee.Name + #0;
            ToFiles.Add(BasePath + SubFindee.Name);
         end  //  end if Findee.Attr
         else if (SubFindee.Attr and faDirectory) <> 0 then begin
            if SubFindee.Name[1] <> '.' then
               AddLVFiles(IncludeTrailingBackslash(SearchPath + SubFindee.Name), BasePath + SubFindee.Name + '\');
         end;  //  end else
      until FindNext(SubFindee) <> 0;  //  end repeat
      FindClose(SubFindee);
   end;  //  end AddFiles procedure

var
   Findee: TSearchRec;

begin
   SetCurrentDir(ExcludeTrailingBackslash(SourcePath));

   if FindFirst(SourcePath + 'drivers\labview\*.*', faAnyFile, Findee) = 0 then begin
      repeat
         while Findee.Name[1] = '.' do
            FindNext(Findee);
         if (Findee.Attr and faDirectory) <> 0 then begin
            AddLVFiles(SourcePath + 'drivers\labview\' + Findee.Name + '\', LVPath);
         end
         else if UpperCase(ExtractFileExt(Findee.Name)) = DriverExt then begin
            ToFiles.Add(DriverPath + Findee.Name);
            FileLog.WriteString(CoNick + ' File Log - ' + PackageName,
                                SourcePath + 'drivers\labview\' + Findee.Name,
                                DriverPath + Findee.Name + ',' + IntToStr(FileAge(SourcePath + 'drivers\labview\' + Findee.Name)));
            FromFileList := FromFileList + '.\drivers\labview\' + Findee.Name + #0;
            ToFileList := ToFileList + DriverPath + Findee.Name + #0;
         end
         else if UpperCase(ExtractFileExt(Findee.Name)) = '.DLL' then begin
            ToFiles.Add(DLL32Path + Findee.Name);
            FileLog.WriteString(CoNick + ' File Log - ' + PackageName,
                                SourcePath + 'drivers\labview\' + Findee.Name,
                                DLL32Path + Findee.Name + ',' + IntToStr(FileAge(SourcePath + 'drivers\labview\' + Findee.Name)));
            FromFileList := FromFileList + '.\drivers\labview\' + Findee.Name + #0;
            ToFileList := ToFileList + DLL32Path + Findee.Name + #0;
         end;
      until FindNext(Findee) <> 0;
   end;  //  end if
   FindClose(Findee);
end;

procedure TMainForm.InstallStartMenuGroup(ObjectPath, Root, Title, Desc: string);
var
   ProgramsPath, MyProgramsPath, LinkName: string;

begin
   ProgramsPath := StartProgramsPath;
   while Pos('/', Root) <> 0 do
      Root[Pos('/', Root)] := '-';
   while Pos('/', Title) <> 0 do
      Title[Pos('/', Title)] := '-';
   MyProgramsPath := IncludeTrailingBackslash(IncludeTrailingBackslash(ProgramsPath) + Root);
   if not DirectoryExists(MyProgramsPath) then
   try
      ForceDirectories(MyProgramsPath);
   except
      MyProgramsPath := ProgramsPath + '\DataAq\';
      if not DirectoryExists(MyProgramsPath) then
         ForceDirectories(MyProgramsPath);
   end;
   LinkName := IncludeTrailingBackslash(MyProgramsPath) + Title + '.lnk';
   CreateShellLink(ObjectPath, LinkName, Desc);
end;

procedure TMainForm.CreateShellLink(sPathObj, sPathLink, sDesc : string);
var
   sl : IShellLink;
   ppf : IPersistFile;
   wcLinkName : array[ 0..Max_Path ] of WideChar;
begin
    OleCheck(CoInitialize(nil));

    OleCheck(CoCreateInstance(OLE2.TGUID(CLSID_ShellLink), nil, CLSCTX_INPROC_SERVER, OLE2.TGUID(IID_IShellLinkA), sl));

    OleCheck(sl.QueryInterface(System.TGUID(IID_IPersistFile), ppf));

    OleCheck(sl.SetDescription(PChar(sDesc)));
    OleCheck(sl.SetPath(PChar(sPathObj)));
    OleCheck(sl.SetWorkingDirectory(PChar(ExtractFilePath(sPathObj))));
 //   OleCheck(sl.SetArguments(PChar(sArguments)));
 //   OleCheck(sl.SetIconLocation(PChar(sIconPath), iIconIndex));
    MultiByteToWideChar(CP_ACP, 0, PChar(sPathLink), -1, wcLinkName, MAX_PATH );

    OleCheck(ppf.Save(wcLinkName, true));

    CoUninitialize;
end;

procedure TMainForm.DestChangeButtonClick(Sender: TObject);
begin
   Application.CreateForm(TChangeDestForm, ChangeDestForm);
   try
      ChangeDestForm.DriveComboBox.Drive := PPath.Caption[1];
      if DirectoryExists(PPath.Caption) then
         ChangeDestForm.DirectoryListBox.Directory := PPath.Caption
      else
         ChangeDestForm.DirectoryListBox.Directory := WindowsDrive;
   except
   end;
   ChangeDestForm.PathEdit.Text := ChangeDestForm.DirectoryListBox.Directory;
   if ChangeDestForm.ShowModal = mrOK then begin
      PPath.Caption := ChangeDestForm.PathEdit.Text;
   end;
   ChangeDestForm.Free;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
   ToFiles.Free;
   DisksIni.Free;
   FileLog.Free;
   LineProducts.Free;
   PvPValues.Free;
   PackageValues.Free;
   FileValues.Free;
   FriendlyValues.Free;
end;

procedure TMainForm.SetupButtonClick(Sender: TObject);
var
  SetupPath: String;

begin
  SetupPath := IncludeTrailingBackslash(PPath.Caption) + 'Setup.exe';
  if WinExec(PChar(SetupPath), SW_SHOWNORMAL) < 32 then
    Application.MessageBox(PChar('Could not find ' + SetupPath), 'Error', MB_ICONSTOP)
  ;
end;

procedure TMainForm.SetupUninstall;
var
  Reg: TRegistry;

begin
   Reg := TRegistry.Create;
   Reg.RootKey := HKEY_LOCAL_MACHINE;

   if Reg.OpenKey(UninstallKey, True) then
      try
         Reg.WriteString('DisplayName', CoName + 'Software');
         Reg.WriteString('UninstallString', WindowsPath + CoNick + 'Uninstall.exe');
         Reg.CloseKey;
      except
         Reg.CloseKey;
      end  //  end try/except
   else
      InstallStartMenuGroup(WindowsPath + CoNick + 'Uninstall.exe', CoNick + ' ' + ProductName.Caption, 'Uninstall ' + CoNick + ' Software', '');

   Reg.Free;
end;

procedure TMainForm.NetButtonClick(Sender: TObject);
begin
  (*
  {$IFDEF ACCES}
    Hide;
    Application.CreateForm(TDLForm, DLForm);
    DLForm.Go(CoHost, CoPath);
    Close;
  {$ENDIF}
  *)
end;

procedure TMainForm.ClientSockConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  (*
  {$IFDEF ACCES}
    //Request headers for web installer; we just want success or failure.
    Socket.SendText('HEAD ' + CoPath + ' HTTP/1.1'#13#10
                  + 'Host: ' + CoHost + #13#10
                  + 'Connection: close'#13#10
                  + #13#10
    );
  {$ENDIF}
  *)
end;

procedure TMainForm.ClientSockDisconnect(Sender: TObject; Socket: TCustomWinSocket);
//var
//  I: Integer;

begin
  (*
  {$IFDEF ACCES}
    I := Pos(' ', RecStr);
    if I = 0 then Exit;
    RecStr := Copy(RecStr, I + 1, MAXINT);
    I := Pos(' ', RecStr);
    if I = 0 then Exit;
    RecStr := Copy(RecStr, 1, I - 1);
    if RecStr = '200' then
      //NetButton.Visible := True
    ;
    RecStr := '';
  {$ENDIF}
  *)
end;

procedure TMainForm.ClientSockRead(Sender: TObject; Socket: TCustomWinSocket);
begin
  RecStr := RecStr + Socket.ReceiveText;
end;

procedure TMainForm.ClientSockError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  ErrorCode := 0; //whatever
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  (*
  {$IFDEF ACCES}
    if (Key = VK_F12) and (Shift = [ssShift, ssCtrl]) then NetButton.Visible := True;
  {$ENDIF}
  *)
end;

end.
